/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	AD同期処理 マッピングノード抽象クラス
//			変更履歴
//				2004.01.08	新規作成	            二條智文
//
package jp.co.ntt.lms.xmo.Ad;

import java.util.*;
import javax.naming.*;
import javax.naming.directory.*;
import jp.co.ntt.lms.xmo.util.DebugLog;
import jp.co.ntt.lms.xmo.util.DataConverter;

/**
 * AD同期処理 マッピングノード抽象クラス。<BR>
 * ADからXMS2オブジェクトにマッピングされた情報を表す抽象クラスです。
 * サブクラスで同期XML作成処理を実装してください。
 * @author T.Nijou
 * @version 2.0.1.0 2004/01/08
 */
public abstract class ADCorpNode {

	// DN(エントリ識別名) を保持します。
	protected String mstrDN;
	/** オブジェクトID */
	protected String mstrOid;

	// 親情報を保持します。
	protected ADCorpNode mobjParent;

	// 子ノードを保持します。
	protected Vector mvecChildNode = new Vector();

	// 子の位置を保持する。
	protected int intIndex = 0;

	/**
	 * 同期XMLを取得します。
	 * @return String 同期XML
	 */
	public abstract String getXML();

	/**
	 * DN(エントリ識別名)を取得します。
	 * @return String DN
	 */
	public String getDN() {
		return mstrDN;
	}

	/**
	 * オブジェクトIDを取得します
	 * @return String oid
	 */
	public String getOid() {
		return mstrOid;
	}

	/**
	 * 子ノードを追加する。
	 * @param objChild 子ノード
	 */
	public void addChild( ADCorpNode objChild ) {
		mvecChildNode.add( objChild );
		// 親に設定
		objChild.setParent(this);
	}

	/**
	 * 親ノードを設定する。
	 * @param objParent 親ノード
	 */
	public void setParent( ADCorpNode objParent ) {
		mobjParent = objParent;
	}

	/**
	 * 親情報を取得する。ROOTノードの親はNULLとなる。
	 * @return ADCorpNode 親ノード
	 */
	public ADCorpNode getParent() {
		return mobjParent;
	}

	/**
	 * 属性から属性値を取得します。
	 * 属性値がテキストデータの場合はそのまま返し、バイナリデータの場合は
	 * Base64エンコードして返します。
	 * @param Attribute attr 属性
	 * @return String テキストデータの場合はそのままテキストデータを返し、
	 *                バイナリデータの場合はBase64エンコードして返します。
	 * @exception NamingException
	 */
	protected String getValue( Attribute attr )
		throws NamingException
	{
		String strRes = null;
		Object objValue = attr.get();
		if( objValue instanceof String ) {
			// 属性値がテキストデータの場合
			strRes = (String)objValue;
		}
		else if( objValue instanceof byte[] ) {
			// 属性値がバイナリデータの場合はBase64エンコードをする
			try {
				strRes = DataConverter.byteArrayToBase64String((byte[])objValue).trim();
			}
			catch(Exception e ) {
				// 何もしない。
			}
		}
		else {
			// 現LDAPプロバイダの仕様ではString, byte[] 以外の値は返さないので
			// ここでは何もしない。
		}

		return strRes;
	}


// ------------- デバック-------------------------------------------------------
	protected void debug(SearchResult si) {
		try{
			Attributes attrs = si.getAttributes();
			if (attrs == null) {
			} else {
				for (NamingEnumeration ae = attrs.getAll();ae.hasMoreElements();)
				{
					Attribute attr = (Attribute)ae.next();
					String attrId = attr.getID();
					for (Enumeration vals = attr.getAll();vals.hasMoreElements();)
					{
						if ( !attr.getID().equals("objectSid") )
						{
						}
						else
						{
							vals.nextElement();
						}
					}
				}
			}
		}
		catch( PartialResultException pe ) {
		}
		catch(NamingException e) {
			e.printStackTrace();
		}
}
// ------------- デバック-------------------------------------------------------

}
